
#include	"adc_ctrl.h"

#include	<conio.h>
#include	<process.h> 

BRDctrl_StreamCBufAlloc g_buf_dscr;
extern BRD_Handle g_hSRV;
extern ULONG g_MemAsFifo;

static void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break;
	case BRDerr_BAD_PARAMETER:
		sprintf_s(msg, "%s: BRDerr_BAD_PARAMETER\n", cmd_str);
		break;
	case BRDerr_BUFFER_TOO_SMALL:
		sprintf_s(msg, "%s: BRDerr_BUFFER_TOO_SMALL\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error, status = %8X\n", cmd_str, real_status);
		break;
	}
	printf(msg);
}

// ,    ,   :
// ADC28X800M, ADC28X1G, ADC10X2G
int CheckClock(BRD_Handle hADC, char* AdcSrvName)
{
	if(lstrcmpi(AdcSrvName, "ADC28X800M") && lstrcmpi(AdcSrvName, "ADC28X1G") && 
	   lstrcmpi(AdcSrvName, "ADC10X2G"))
		return 1; //      
	printf("Clock checking...\r");
	Sleep(1000);
	ULONG status = 1;
	if(hADC)
	{
		for(int i = 0; i < 3; i++)
		{
			BRD_ClkMode clk_mode;
			status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETCLKMODE, &clk_mode);
			status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETCLKMODE, &clk_mode);
			Sleep(10);
			ULONG fifo_status;
			BRD_ctrl(hADC, 0, BRDctrl_ADC_FIFOSTATUS, &fifo_status);
			if(fifo_status & 0x1000)
			{
				status = 1;
				break;
			}
			else
				status = 0;
		}
	}
	printf("                    \r");
	if(status)
		printf("Clock is OK\n");
	else
		printf("Clock error\n");
	return status;
}

#ifdef _ADM214X200M

#include	"CtrlAdc214x200m.h"

ADC214X200MSRV_MU mu_dflt = {
	sizeof(ADC214X200MSRV_MU),
	0x1,						//   
	1,							//   (2 - Master, 1 - Single, 0 - Slave)
	50000000.0,					//   () (   = 1, 2, 4, 8, 16, 32, 64, 128, 256)
	100000000.0,				//      ()
	2,							//    (0 - , 1 -    (ver 1.1+), 2 -   , 0x81 - )
	0.50, 0.50,					//     (10.0 , 2.0 , 0.5 , 0.1 )
	0.360, -0.054,					//     
	1, 1,						//      (0 - 1 O, 1 - 50 O)
	1, 1,						//  (1) /  (0)       
	0,							// 0 - 16 , 1 - 8 
	0,							//   
	0,							//    
	0,							//    
	129,						//   
	0,							//   
	0,							//   
	0,							//   
	0,							//    
	0,							//    
	0,							//    
	0,							//   : 0 - , 7 -  , 10 -  DDS (only for AMBPEX8)
	0,							// 1 -    
	0,							//   
	0,							// 1 -    
	0,							// 1 -   -, 0 -   -
	0,							// 1 -     
	3,							//   : 0 -  0, 1 -  1, 2 - , 3 - 
	0,							// 1 -    
	0.123,						//     ( -2.5   +2.5     )
	0.0, 0.0,					//     ( -2%  +2%)
	0,							// 1 -   
};

#endif // _ADM214X200M

#ifdef _ADM214X400M

#include	"CtrlAdc214x400m.h"

ADC214X400MSRV_MU mu_dflt = {
	sizeof(ADC214X400MSRV_MU),
	0,							//  : 0 - , 1 - WB HF, 2 - WB LF
	0x3,						//   
	1,							//   (2 - Master, 1 - Single, 0 - Slave)
	50000000.0,					//   () (   = 1, 2, 4, 8, 16, 32, 64, 128, 256)
	100000000.0,				//      ()
	1,							//    (0 - , 1 -    (ver 1.1+), 2 -   , 0x81 - )
	0.50, 0.50,					//     (10.0 , 2.0 , 0.5 , 0.1 )
	0.360, -0.054,					//     
	1, 1,						//      (0 - 1 O, 1 - 50 O)
	1, 1,						//  (1) /  (0)       
	0,							// 0 - 16 , 1 - 8 
	0,							//   
	0,							//    
	0,							//    
	129,						//   
	0,							//   
	0,							//   
	0,							//   
	0,							//    
	0,							//    
	0,							//    
	0,							//   : 0 - , 7 -  , 10 -  DDS (only for AMBPEX8)
	0,							// 1 -    
	0,							//   
	0,							// 1 -    
	0,							// 1 -   -, 0 -   -
	0,							// 1 -     
	3,							//   : 0 -  0, 1 -  1, 2 - , 3 - 
	0,							// 1 -    
	0.123,						//     ( -2.5   +2.5     )
	0.0, 0.0,					//     ( -2%  +2%)
	0,							// 1 -   
};

#endif // _ADM214X400M

#ifdef _ADM216X100M

#include	"CtrlAdc216x100m.h"

ADC216X100MSRV_MU mu_dflt = {
	sizeof(ADC216X100MSRV_MU),
	0x1,						//   
	1,							//   (2 - Master, 1 - Single, 0 - Slave)
	50000000.0,					//   () (   = 1, 2, 4, 8, 16)
	100000000.0,				//      ()
	1,							//    (0 - , 1,2,3 -  1,2,3  , 0x81 - )
	2.0, 2.0,					//     (4.0 , 2.66 , 2.0 , 1.33 , 0.2 , 0.133 , 0.1 , 0.066 )
	0.360, -0.054,				//     
	1, 1,						//      (0 - 1 kO, 1 - 50 O)
	1, 1,						//  (1) /  (0)       
	0,							// 0 - 16 , 1 - 8 
	0,							//   
	0,							//    
	0,							//    
	129,						//   
	0,							//   
	0,							//   
	0,							//   
	0,							//    
	0,							//    
	0,							//    
	0,							//   : 0 - , 2 - SDX ( 1), 10 -  DDS (only for AMBPEX8)
	0,							// 1 -    
	0,							//   
	0,							// 1 -    
	0,							// 1 -   -, 0 -   -
	0,							// 1 -     
	0.0,						//    ( -2.5   2.5 )
	0,							// 1 -   
};

#endif // _ADM216X100M

S32 AdcSettings(BRD_Handle hADC, int idx, char* srvName, char* iniFileName)
{
	S32		status;

	//ULONG master = BRDims_SINGLE; //    () 
	//status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETMASTER, &master);

	BRD_AdcCfg adc_cfg;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETCFG, &adc_cfg);
	printf("ADC Config: FIFO size = %d kBytes\n", adc_cfg.FifoSize / 1024);

	//ULONG chan_mask = 3; //    
	//status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETCHANMASK, &chan_mask);
	//int num_chan = (chan_mask & 0x1) + ((chan_mask >> 1) & 0x1);

	//    
	TCHAR iniFilePath[MAX_PATH];
	TCHAR iniSectionName[MAX_PATH];
	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);
	lstrcat(iniFilePath, iniFileName);
	sprintf_s(iniSectionName, "device%d_%s%d", idx, srvName, 0);

#ifdef _ADM214X200M
	BRD_AdcSpec adcSpec;
	adcSpec.command = ADC214X200Mcmd_SETMU;
	adcSpec.arg= (PVOID)&mu_dflt; 
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETSPECIFIC,  &adcSpec); 
	if(!BRD_errcmp(status, BRDerr_OK))
		DisplayError(status, "ADC214X200Mcmd_SETMU");
#else
 #ifdef _ADM216X100M
	BRD_AdcSpec adcSpec;
	adcSpec.command = ADC216X100Mcmd_SETMU;
	adcSpec.arg= (PVOID)&mu_dflt; 
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETSPECIFIC,  &adcSpec); 
	if(!BRD_errcmp(status, BRDerr_OK))
		DisplayError(status, "ADC216X100Mcmd_SETMU");
 #else
	#ifdef _ADM214X400M
		BRD_AdcSpec adcSpec;
		adcSpec.command = ADC214X400Mcmd_SETMU;
		adcSpec.arg= (PVOID)&mu_dflt; 
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETSPECIFIC,  &adcSpec); 
		if(!BRD_errcmp(status, BRDerr_OK))
			DisplayError(status, "ADC214X400Mcmd_SETMU");
	#else
		BRD_IniFile ini_file;
		lstrcpy(ini_file.fileName, iniFilePath);
		lstrcpy(ini_file.sectionName, iniSectionName);
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_READINIFILE, &ini_file);
   #endif
 #endif
#endif

	//         
	BRD_SyncMode sync_mode;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETSYNCMODE, &sync_mode);
	if(strstr(srvName, "ADC1624X192") || strstr(srvName, "ADC818X800"))
	{
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_ADC_GETSYNCMODE: source = %d, value = %.2f MHz, rate = %.2f kHz\n", 
											sync_mode.clkSrc, sync_mode.clkValue/1000000, sync_mode.rate/1000);
		else
			DisplayError(status, "BRDctrl_ADC_GETSYNCMODE");
	}
	else
	{
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_ADC_GETSYNCMODE: source = %d, value = %.2f MHz, rate = %.2f MHz\n", 
											sync_mode.clkSrc, sync_mode.clkValue/1000000, sync_mode.rate/1000000);
		else
			DisplayError(status, "BRDctrl_ADC_GETSYNCMODE");
	}
	//    
	if(strstr(srvName, "ADC212X200M") ||
	   strstr(srvName, "ADC10X2G") ||
	   strstr(srvName, "ADC214X200M") ||
	   strstr(srvName, "ADC28X1G") ||
	   strstr(srvName, "ADC214X400M") ||
	   strstr(srvName, "ADC210X1G")
	   )
	{ //    
	    // : ADC212X200M, ADC10X2G, ADC214X200M, ADC28X1G, ADC214X400M
		BRD_AdcStartMode start;
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETSTARTMODE, &start);
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_ADC_GETSTARTMODE: start source = %d\n", start.src);
		else
			DisplayError(status, "BRDctrl_ADC_GETSTARTMODE");
	}
	else
	{ //     
		// : ADC414X65M, ADC216X100M, ADC1624X192, ADC818X800, ADC1612X1M
		BRD_StartMode start;
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETSTARTMODE, &start);
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_ADC_GETSTARTMODE: start source = %d\n", start.startSrc);
		else
			DisplayError(status, "BRDctrl_ADC_GETSTARTMODE");

		if(start.startSrc == BRDsts_CMP1)
		{	//    1 (      SDX)
			TCHAR Buffer[128];
			BRD_CmpSC cmp_sc;
			cmp_sc.src = BRDcmps_EXTSTCLK;
			cmp_sc.thr[0] = 0.0;
			GetPrivateProfileString(iniSectionName, "ComparatorThresholdSDX", "0.0", Buffer, sizeof(Buffer), iniFilePath);
			cmp_sc.thr[1] = atof(Buffer);//0.0;

			//      
			status = BRD_ctrl(hADC, 0, BRDctrl_CMPSC_SET, &cmp_sc);
			if(BRD_errcmp(status, BRDerr_OK))
				printf("BRDctrl_CMPSC_SET: comparator source = %d, threshold = %.2f\n", cmp_sc.src, cmp_sc.thr[1]);
			else
				DisplayError(status, "BRDctrl_CMPSC_SET");
		}
	}

	//    
	ULONG chan_mask = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETCHANMASK, &chan_mask);
	//status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETCHANMASK, &chan_mask);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_ADC_GETCHANMASK: chan_mask = %0X\n", chan_mask);
	else
		DisplayError(status, "BRDctrl_ADC_GETCHANMASK");
	U32 i = 0;
	S32 numChan  = 0;
	//numChan = (chan_mask & 0x1) + ((chan_mask >> 1) & 0x1) + ((chan_mask >> 2) & 0x1) + ((chan_mask >> 3) & 0x1);
	for(i = 0; i < MAX_CHAN; i++)
		numChan += (chan_mask >> i) & 0x1;

	//   
	ULONG format = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETFORMAT, &format);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_ADC_GETFORMAT: format = %0X\n", format);
	else
		DisplayError(status, "BRDctrl_ADC_GETFORMAT");

	BRD_ValChan value_chan;
	for(i = 0; i < adc_cfg.NumChans; i++)
//	for(i = 0; i < numChan; i++)
	{
		value_chan.chan = i;
		printf("Channel %d:\n", value_chan.chan);

		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETINPRANGE, &value_chan);
		if(BRD_errcmp(status, BRDerr_OK))
//			printf("BRDctrl_ADC_GETINPRANGE: range of channel %d = %f\n", value_chan.chan, value_chan.value);
			printf("Range = %f\n", value_chan.value);
		else
			DisplayError(status, "BRDctrl_ADC_GETINPRANGE");

		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETBIAS, &value_chan);
		if(BRD_errcmp(status, BRDerr_OK))
//			printf("BRDctrl_ADC_GETBIAS: bias of channel %d = %f\n", value_chan.chan, value_chan.value);
			printf("Bias = %f\n", value_chan.value);
		else
			DisplayError(status, "BRDctrl_ADC_GETBIAS");

		if(strstr(srvName, "ADC212X200M")
			 || strstr(srvName, "ADC214X200M")
			 || strstr(srvName, "ADC214X400M")
			 || strstr(srvName, "ADC10X2G")
			 || strstr(srvName, "ADC216X100M"))
		{
			status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETINPRESIST, &value_chan);
			if(BRD_errcmp(status, BRDerr_OK))
			{
				if(value_chan.value)
						printf("Input resist is 50 Om\n", value_chan.chan);
				else
				{
					if(strstr(srvName, "ADC216X100M"))
						printf("Input resist is 1 kOm\n", value_chan.chan);
					else
						printf("Input resist is 1 MOm\n", value_chan.chan);
				}
			}
			else
				DisplayError(status, "BRDctrl_ADC_GETINPRESIST");
		}
		if(strstr(srvName, "ADC28X1G")
			|| strstr(srvName, "ADC212X200M")
			|| strstr(srvName, "ADC214X200M")
			|| strstr(srvName, "ADC214X400M")
			|| strstr(srvName, "ADC10X2G")
			|| strstr(srvName, "ADC216X100M"))
		{
			status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETDCCOUPLING, &value_chan);
			if(BRD_errcmp(status, BRDerr_OK))
			{
				if(value_chan.value)
					printf("Input is OPENED\n", value_chan.chan);
				else
					printf("Input is CLOSED\n", value_chan.chan);
			}
			else
				DisplayError(status, "BRDctrl_ADC_GETDCCOUPLING");
		}
	}

	//GetPrivateProfileString("Option", "IsPreTriggerMode", "0", Buffer, sizeof(Buffer), iniFilePath);
	//g_PretrigMode = atoi(Buffer);
	//GetPrivateProfileString("Option", "PreTriggerSamples", "16", Buffer, sizeof(Buffer), iniFilePath);
	//g_nPreTrigSamples = _atoi64(Buffer);

	//BRD_PretrigMode pretrigger;
	//pretrigger.enable = 0;
	//pretrigger.assur = 0;
	//pretrigger.external = 0;
	//if(g_PretrigMode)
	//{
	//	pretrigger.enable = 1;
	//	pretrigger.assur = (g_PretrigMode == 2) ? 1 : 0;
	//}
	//ULONG sample_size = format ? sizeof(char) : sizeof(short);
	//pretrigger.size = ULONG((g_nPreTrigSamples * numChan * sample_size) / sizeof(ULONG));
	//status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETPRETRIGMODE, &pretrigger);

//	printf("Press any key to continue...\n");
//	_getch();

	CheckClock(hADC, srvName);

	return numChan;
}

/*
//   
S32 AdcSettings0(BRD_Handle hADC)
{
	S32		status;

	//             
	BRD_SyncMode sync_mode;
	sync_mode.clkSrc = BRDclks_ADC_EXTCLK;
	sync_mode.clkValue = 200000000.; // 200 MHz
	sync_mode.rate = 150000000.; // 150 MHz
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETSYNCMODE, &sync_mode);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_ADC_SETSYNCMODE: clock = %f, rate = %f\n", sync_mode.clkValue, sync_mode.rate);
	else
		DisplayError(status, "BRDctrl_ADC_SETSYNCMODE");

	//       
	double rate = 100000000.; // 100 MHz
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETRATE, &rate);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_ADC_SETRATE: rate = %f\n", rate);
	else
		DisplayError(status, "BRDctrl_ADC_SETRATE");

	//         
	BRD_ClkMode clk_mode;
	clk_mode.src = BRDclks_ADC_EXTCLK;
	clk_mode.value = 100000000.;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETCLKMODE, &clk_mode);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_ADC_SETCLKMODE: source = %d, value = %f\n", clk_mode.src, clk_mode.value);
	else
		DisplayError(status, "BRDctrl_ADC_SETCLKMODE");

	//    
	BRD_AdcStartMode start;
	start.src = BRDsts_ADC_PRG;
	start.inv = 0;
	start.level = 0.0;
	if(start.src != BRDsts_ADC_PRG)
		start.stndStart.startSrc = BRDsts_SUBMOD;
	else
		start.stndStart.startSrc = BRDsts_PRG;
	start.stndStart.startInv = 0;
	start.stndStart.trigOn = 1;
	start.stndStart.trigStopSrc = BRDsts_PRG;
	start.stndStart.stopInv = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETSTARTMODE, &start);
	if(BRD_errcmp(status, BRDerr_OK))
		printf("BRDctrl_ADC_SETSTARTMODE: start source = %d\n", start.src);
	else
		DisplayError(status, "BRDctrl_ADC_SETSTARTMODE");

	BRD_ValChan value_chan;
	for(int i = 0; i < BRD_CHANCNT; i++)
	{
		value_chan.chan = i;
		value_chan.value = 0.5;
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETINPRANGE, &value_chan);
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_ADC_SETINPRANGE: range of channel %d = %f\n", value_chan.chan, value_chan.value);
		else
			DisplayError(status, "BRDctrl_ADC_SETINPRANGE");
		value_chan.value = -0.5;
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETBIAS, &value_chan);
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_ADC_SETBIAS: bias of channel %d = %f\n", value_chan.chan, value_chan.value);
		else
			DisplayError(status, "BRDctrl_ADC_SETBIAS");
		value_chan.value = 1.;
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETINPRESIST, &value_chan);
		if(!BRD_errcmp(status, BRDerr_OK))
			DisplayError(status, "BRDctrl_ADC_SETINPRESIST");
		value_chan.value = 1.;
		status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETDCCOUPLING, &value_chan);
		if(!BRD_errcmp(status, BRDerr_OK))
			DisplayError(status, "BRDctrl_ADC_SETDCCOUPLING");
	}
	return status;
}
*/

//   SDRAM
S32 SdramSettings(ULONG mem_mode, BRD_Handle hADC, ULONG& bBuf_size)
{
	S32		status;

	ULONG target = 2; //      
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_SETTARGET, &target);

	if(mem_mode == 2)
	{	// as a FIFO
		ULONG fifo_mode = 1; //    FIFO
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_SETFIFOMODE, &fifo_mode);
	}
	else
	{
		ULONG rd_mode = 0; //     
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_SETREADMODE, &rd_mode);

		ULONG addr = 0;
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_SETSTARTADDR, &addr); //   
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_SETREADADDR, &addr); //   

		ULONG mem_size = bBuf_size >> 2; //      32- 
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_SETMEMSIZE, &mem_size);
		bBuf_size = mem_size << 2; //       
		if(BRD_errcmp(status, BRDerr_OK))
			printf("BRDctrl_SDRAM_SETMEMSIZE: SDRAM buffer size = %d bytes\n", bBuf_size);
		else
			DisplayError(status, "BRDctrl_SDRAM_SETMEMSIZE");
	}
	return status;
}

//     SDRAM      
//S32 DaqIntoSdram(BRD_Handle hADC, PVOID pSig, ULONG bBufSize, int num_chan)
S32 DaqIntoSdram(BRD_Handle hADC)
{
	S32		status;
	ULONG Status = 0;
	ULONG Enable = 1;

	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_FIFORESET, NULL); //  FIFO 
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFORESET, NULL); //  FIFO SDRAM
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   

	//   
	do {
//		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFOSTATUS, &Status);
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ISACQCOMPLETE, &Status);
	} while(!Status);
//	} while(Status & 0x10);

	Enable = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM

	//  ,    
	//status = GetPtertrigData(hADC, num_chan);

	//BRD_DataBuf data_buf;
	//data_buf.pData = pSig;
	//data_buf.size = bBufSize;
	//status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETDATA, &data_buf);

	return status;
}

typedef struct _THREAD_PARAM {
	BRD_Handle handle;
	int idx;
} THREAD_PARAM, *PTHREAD_PARAM;

HANDLE g_hThread = NULL;
THREAD_PARAM thread_par;
HANDLE g_hUserEvent = NULL;

//     SDRAM  -   
unsigned __stdcall ThreadDaqIntoSdramDMA(void* pParams)
{
	S32		status;
	ULONG Status = 0;
	ULONG evt_status = BRDerr_OK;
	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);
	PTHREAD_PARAM pThreadParam = (PTHREAD_PARAM)pParams;
	BRD_Handle hADC = pThreadParam->handle;
	int idx = pThreadParam->idx;

	ULONG Enable = 1;

	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_IRQACQCOMPLETE, &Enable); //        SDRAM
	//status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFOSTATUS, &Status);

	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_FIFORESET, NULL); //  FIFO 
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFORESET, NULL); //  FIFO SDRAM
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   

	//   
	BRD_WaitEvent waitEvt;
	waitEvt.timeout = 20000; //      20 .
	waitEvt.hAppEvent = g_hUserEvent;
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_WAITACQCOMPLETEEX, &waitEvt);
	if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	//    -,  
		evt_status = status;
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFOSTATUS, &Status);
		DisplayError(status, "TIME-OUT WAITACQCOMPLETE");
	}
	evt_status = status;

	Enable = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM

	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_IRQACQCOMPLETE, &Enable); //        SDRAM

//	CloseHandle(g_hUserEvent);

	if(!BRD_errcmp(evt_status, BRDerr_OK))
//	if(BRD_errcmp(evt_status, BRDerr_SIGNALED_APPEVENT))
//	if(evt_status == BRDerr_SIGNALED_APPEVENT)
		return evt_status;

	//  ,    
//	status = GetPtertrigData(hADC, num_chan);

	// ,     
	ULONG tetrad;
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETSRCSTREAM, &tetrad);
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_SETSRC, &tetrad);

	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_RESETFIFO, NULL);
//	BRDctrl_StreamCBufStart start_pars;
//	start_pars.isCycle = 0; //   
//	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_START, &start_pars);
////	ULONG msTimeout = 20000; //      20 .
////	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
//	waitEvt.timeout = 20000; //      20 .
//	waitEvt.hAppEvent = g_hUserEvent;
//	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_WAITBUFEX, &waitEvt);
//	if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
//	{	//    -,  
//		evt_status = status;
//		status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
//		DisplayError(status, "TIME-OUT");
//	}
//	evt_status = status;
//	if(BRD_errcmp(evt_status, BRDerr_SIGNALED_APPEVENT))
//		status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
//	if(!BRD_errcmp(evt_status, BRDerr_OK))
//		return evt_status;
	return status;
}

//     
S32 StartDaqIntoSdramDMA(BRD_Handle hADC, int idx)
{
	S32		status = BRDerr_OK;
    unsigned threadID;

	thread_par.handle = hADC;
	thread_par.idx = idx;
	g_hUserEvent = CreateEvent( 
							NULL,   // default security attributes
							FALSE,  // auto-reset event object
							FALSE,  // initial state is nonsignaled
							NULL);  // unnamed object

	// Create thread
	g_hThread = (HANDLE)_beginthreadex( NULL, 0, &ThreadDaqIntoSdramDMA, &thread_par, 0, &threadID );
	return 1;
}

//   
S32 CheckDaqIntoSdramDMA()
{
	// check for terminate thread
    ULONG ret = WaitForSingleObject(g_hThread, 0);
	if(ret == WAIT_TIMEOUT)
		return 0;
	return 1;
}

//   ,        SDRAM     
void BreakDaqIntoSdramDMA()
{
	SetEvent(g_hUserEvent); //    Signaled
    WaitForSingleObject(g_hThread, INFINITE); // Wait until thread terminates
//	CloseHandle(g_hUserEvent);
//	CloseHandle(g_hThread);
}

//           
void EndDaqIntoSdramDMA()
{
	CloseHandle(g_hUserEvent);
	CloseHandle(g_hThread);
	g_hUserEvent = NULL;
	g_hThread = NULL;
}

//     SDRAM  -   
//S32 DaqIntoSdramDMA(BRD_Handle hADC, int idx, ULONG bBufSize, int num_chan)
S32 DaqIntoSdramDMA(BRD_Handle hADC)
{
//	printf("DAQ into SDRAM\n");
	S32		status;
	//ULONG Status = 0;
	ULONG isAcqComplete = 0;
	ULONG Enable = 1;
	int fl_error = 0;

	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_IRQACQCOMPLETE, &Enable); //        SDRAM
	//status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFOSTATUS, &Status);

	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_FIFORESET, NULL); //  FIFO 
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFORESET, NULL); //  FIFO SDRAM
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   

	//   
//	do {
////		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFOSTATUS, &Status);
//		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ISACQCOMPLETE, &Status);
//	} while(!Status);
////	} while(Status & 0x10);

	ULONG msAcqTimeout = 20000; //      20 .
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_WAITACQCOMPLETE, &msAcqTimeout);
	if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	//    -,  ...
		//status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFOSTATUS, &Status);
		//DisplayError(status, "TIME-OUT WAITACQCOMPLETE");
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ISACQCOMPLETE, &isAcqComplete);
		char msg[255];
		sprintf(msg, "BRDctrl_SDRAM_WAITACQCOMPLETE is TIME-OUT(%d sec.), isAcqComplete=%d", msAcqTimeout/1000, isAcqComplete);
		DisplayError(status, msg);
		fl_error = 1;
	}

	Enable = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM

	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_IRQACQCOMPLETE, &Enable); //        SDRAM

	if(fl_error)
		return -1;
	//  ,    
	//status = GetPtertrigData(hADC, num_chan);

	// ,     
	ULONG tetrad;
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETSRCSTREAM, &tetrad);
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_SETSRC, &tetrad);

	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_RESETFIFO, NULL);
	//BRDctrl_StreamCBufStart start_pars;
	//start_pars.isCycle = 0; //   
	//status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_START, &start_pars);
	//ULONG msTimeout = 20000; //      20 .
	//status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
	//if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	//{	//    -,  
	//	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
	//	DisplayError(status, "TIME-OUT");
	//}

	return status;
}

//    
S32 DataFromMem(BRD_Handle hADC, PVOID pBuf, ULONG bBufSize, ULONG DmaOn)
{
	S32		status;
	if(DmaOn)
	{
		BRDctrl_StreamCBufStart start_pars;
		start_pars.isCycle = 0; //   
		status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //        

		ULONG msTimeout = 5000; //      5 .
		status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
		if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
		{	//    -,  
			status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
			DisplayError(status, "TIME-OUT");
		}
	}
	else
	{
		BRD_DataBuf data_buf;
		data_buf.pData = pBuf;
		data_buf.size = bBufSize;
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETDATA, &data_buf);
	}
	return status;
}

//     FIFO      
S32 DaqIntoFifo(BRD_Handle hADC, PVOID pSig, ULONG bBufSize, int DspMode)
{
	S32		status;
	ULONG Status = 0;
	ULONG Enable = 1;

	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_FIFORESET, NULL); //  FIFO 
//	if(DspMode)
//		status = BRD_ctrl(hADC, 0, BRDctrl_DSPNODE_FIFORESET, NULL); //  FIFO  
	if(g_MemAsFifo)
	{
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFORESET, NULL); //  FIFO SDRAM
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM
	}
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   

	//   FIFO
	do {
//		if(DspMode)
//			status = BRD_ctrl(hADC, 0, BRDctrl_DSPNODE_FIFOSTATUS, &Status);
//		else
			if(g_MemAsFifo)
				status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFOSTATUS, &Status);
			else
				status = BRD_ctrl(hADC, 0, BRDctrl_ADC_FIFOSTATUS, &Status);
	} while(Status & 0x40);

	Enable = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   

	if(g_MemAsFifo)
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM

	BRD_DataBuf data_buf;
	data_buf.pData = pSig;
	data_buf.size = bBufSize;
//	if(DspMode)
//		status = BRD_ctrl(hADC, 0, BRDctrl_DSPNODE_GETDATA, &data_buf);
//	else
		if(g_MemAsFifo)
			status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETDATA, &data_buf);
		else
			status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETDATA, &data_buf);


	return status;
}

//     FIFO  -   
S32 DaqIntoFifoDMA(BRD_Handle hADC, int idx, ULONG bBufSize, int DspMode)
{
	//if(DspMode)
	//	printf("DAQ into DSP FIFO\n");
	//else
	//	printf("DAQ into ADC FIFO\n");
	S32		status;
	ULONG Status = 0;
	ULONG Enable = 1;

	//      
	ULONG flag = BRDstrm_DRQ_HALF; //   - FIFO  
//	ULONG flag = BRDstrm_DRQ_ALMOST; //   - FIFO  
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_SETDRQ, &flag);
	if(!BRD_errcmp(status, BRDerr_OK))
		DisplayError(status, "BRDctrl_STREAM_SETDRQ");

	//     
	ULONG tetrad;
//	if(DspMode)
//		status = BRD_ctrl(hADC, 0, BRDctrl_DSPNODE_GETSRCSTREAM, &tetrad); //      
//	else
		if(g_MemAsFifo)
			status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETSRCSTREAM, &tetrad); //     SDRAM
		else
			status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETSRCSTREAM, &tetrad); //     
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_SETSRC, &tetrad);

	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_FIFORESET, NULL); //  FIFO 
//	if(DspMode)
//		status = BRD_ctrl(hADC, 0, BRDctrl_DSPNODE_FIFORESET, NULL); //  FIFO  
	if(g_MemAsFifo)
	{
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_FIFORESET, NULL); //  FIFO SDRAM
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM
	}
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_RESETFIFO, NULL);

	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 0; //   
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   
	//ULONG msTimeout = 20000; //      20 .
	//status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
	//if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	//{	//    -,  
	//	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
	//	DisplayError(status, "TIME-OUT");
	//}
	ULONG msTimeout = 0; //   ( ) -   Ctrl-Break
	int i = 0;
	for(i = 0; i < 200; i++)
	{
		status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
		if(BRD_errcmp(status, BRDerr_OK))
			break;
		Sleep(100);
	}
	if(i>=200)
	{	//    -,  
		status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
		DisplayError(status, "TIME-OUT");
	}

	Enable = 0;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_ENABLE, &Enable); //   

	if(g_MemAsFifo)
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM

	return status;
}

	//  ,    
S32 GetPtertrigData(BRD_Handle hADC, int num_chan)
{
	S32		status;
	//         
	ULONG start_event;
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETPRETRIGEVENT, &start_event);
	ULONG bStartEvent = start_event << 2; //   
	//   
	ULONG prec_event;
	status = BRD_ctrl(hADC, 0, BRDctrl_ADC_GETPREVENTPREC, &prec_event);
	ULONG bPrecEvent = prec_event << 1; //   
	bStartEvent += bPrecEvent * num_chan;
	//        
	ULONG isPassMemEnd;
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_ISPASSMEMEND, &isPassMemEnd);
	//     
	ULONG acq_size;
	status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETACQSIZE, &acq_size);
	ULONG bRealSize = acq_size << 2; //   

	return status;
}

extern BRD_Info	g_info;

//         
S32 AllocDaqBuf(BRD_Handle hADC, PVOID* pSig, ULONG* pbytesBufSize, ULONG bufType)
{
	S32		status;

	void* pBuffer = NULL;
	if(2 == bufType)
	{
		pBuffer = malloc(*pbytesBufSize);
//		pBuffer = VirtualAlloc(NULL, bBufSize, MEM_COMMIT, PAGE_READWRITE);
		if(!pBuffer)
		{
			printf("VirtualAlloc() is error!!!\n");
			return -1; // error
		}
	}
	g_buf_dscr.dir = BRDstrm_DIR_IN;
	g_buf_dscr.isCont = bufType; // 0 -      , 1 -  
	g_buf_dscr.blkNum = 1;
	g_buf_dscr.blkSize = *pbytesBufSize;
	g_buf_dscr.ppBlk = new PVOID[g_buf_dscr.blkNum];
	if(g_buf_dscr.isCont == 2)
		g_buf_dscr.ppBlk[0] = pBuffer;
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_ALLOC, &g_buf_dscr);
	if(!BRD_errcmp(status, BRDerr_OK) && !BRD_errcmp(status, BRDerr_PARAMETER_CHANGED))
		DisplayError(status, "BRDctrl_STREAM_CBUF_ALLOC");
	if(BRD_errcmp(status, BRDerr_PARAMETER_CHANGED))
	{
		printf("Warning!!! BRDctrl_STREAM_CBUF_ALLOC: BRDerr_PARAMETER_CHANGED\n");
		status = BRDerr_OK;
	}
	*pSig = g_buf_dscr.ppBlk[0];
	*pbytesBufSize = g_buf_dscr.blkSize;
//	printf("BRDctrl_STREAM_CBUF_ALLOC:: %d kBytes, memory type = %d\n", (*pbytesBufSize)/1024, bufType);
	return status;
}

//         
S32 FreeDaqBuf(BRD_Handle hADC)
{
	S32		status;
	status = BRD_ctrl(hADC, 0, BRDctrl_STREAM_CBUF_FREE, NULL);
	if(!BRD_errcmp(status, BRDerr_OK))
		DisplayError(status, "BRDctrl_STREAM_CBUF_FREE");
	if(g_buf_dscr.isCont == 2)
		free(g_buf_dscr.ppBlk[0]);
//		VirtualFree(g_buf_dscr.ppBlk[0], 0, MEM_RELEASE);
	delete[] g_buf_dscr.ppBlk;
	return status;
}

unsigned __stdcall DirWriteIntoFile(void* pParams);

int g_flbreak = 0;

ULONG g_bufType;
ULONG g_fileBufSize;
ULONG g_fileBufNum;

void DirectFile(ULONG bufType, ULONG FileBufSize, ULONG FileBufNum)
{
	HANDLE hThread;
	unsigned threadID;
	THREAD_PARAM thread_par;

	g_bufType = bufType;
	g_fileBufSize = FileBufSize;
	g_fileBufNum = FileBufNum;

	g_flbreak = 0;
	thread_par.handle = g_hSRV;
	thread_par.idx = 0;
	hThread = (HANDLE)_beginthreadex( NULL, 0, &DirWriteIntoFile, &(thread_par), 0, &(threadID) );

	    // Wait until threads terminates
    WaitForSingleObject(hThread, INFINITE );
    CloseHandle(hThread);
}

extern char g_dirFileName[];
//extern ULONG g_flDirFileName;

unsigned __stdcall DirWriteIntoFile(void* pParams)
{
	S32		status = BRDerr_OK;
	ULONG Status = 0;
	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);
	PTHREAD_PARAM pThreadParam = (PTHREAD_PARAM)pParams;
	BRD_Handle hSrv = pThreadParam->handle;
	int idx = pThreadParam->idx;

	TCHAR fileName[MAX_PATH];
	if(idx)
		sprintf_s(fileName, "%s_%d.bin", g_dirFileName, idx);
	else
		lstrcpy(fileName, g_dirFileName);

	HANDLE hfile = CreateFile(	fileName,
								GENERIC_WRITE,
//								FILE_SHARE_WRITE | FILE_SHARE_READ,
								0,
								NULL,
								CREATE_ALWAYS,
//								FILE_ATTRIBUTE_NORMAL,
							    FILE_FLAG_NO_BUFFERING,// | FILE_FLAG_WRITE_THROUGH,         
								NULL);
	if(hfile == INVALID_HANDLE_VALUE)
	{
		printf("Create file error\n");
		return status;
	}
	ULONG nNumberOfWriteBytes;


	BRDctrl_StreamCBufAlloc buf_dscr;
	buf_dscr.dir = BRDstrm_DIR_IN;
	buf_dscr.isCont = g_bufType; // 0/1 -    /  
	buf_dscr.blkNum = 2;
	buf_dscr.blkSize = g_fileBufSize;
	buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];
	status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr);

	//      
	ULONG flag = BRDstrm_DRQ_HALF; //   - FIFO  
//	ULONG flag = g_DrqFlag; //BRDstrm_DRQ_HALF; //   - FIFO  
//	ULONG flag = BRDstrm_DRQ_ALMOST;
	status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_SETDRQ, &flag);

	//     
	ULONG tetrad;
	if(g_MemAsFifo)
		status = BRD_ctrl(hSrv, 0, BRDctrl_SDRAM_GETSRCSTREAM, &tetrad); //     SDRAM
	else
		status = BRD_ctrl(hSrv, 0, BRDctrl_ADC_GETSRCSTREAM, &tetrad); //     
	status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_SETSRC, &tetrad);

	ULONG Enable = 1;
	status = BRD_ctrl(hSrv, 0, BRDctrl_ADC_FIFORESET, NULL); //  FIFO 
	status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_RESETFIFO, NULL);
	if(g_MemAsFifo)
	{
		status = BRD_ctrl(hSrv, 0, BRDctrl_SDRAM_FIFORESET, NULL); //  FIFO SDRAM
		status = BRD_ctrl(hSrv, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM
	}

	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 1; //  
	status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
	status = BRD_ctrl(hSrv, 0, BRDctrl_ADC_ENABLE, &Enable); //   

	printf("Data writing into file...\n");
	ULONG curbuf = 0;
	int cnt = 0;
	int errcnt = 0;
	ULONG msTimeout = 40000; //      40 .
	for(ULONG i = 0; i < g_fileBufNum; i++)
	{
		//status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &g_DirMsTimeout);
		status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
		if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
		{	//    -,  
			status = BRD_ctrl(hSrv, 0, BRDctrl_ADC_FIFOSTATUS, &Status);
			printf("ADC FIFO Status = 0x%04X\n", Status);
			status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_CBUF_STOP, NULL);
			DisplayError(status, "TIME-OUT");
			break;
		}
		if(!idx && GetAsyncKeyState(VK_ESCAPE))
		{
			g_flbreak = 1;
			_getch();
			break; 
		}
		if(g_flbreak)
			break; 
//		BOOL bResult = WriteFile(hfile, buf_dscr.ppBlk[curbuf], buf_dscr.blkSize, &nNumberOfWriteBytes, NULL);
		WriteFile(hfile, buf_dscr.ppBlk[curbuf], buf_dscr.blkSize, &nNumberOfWriteBytes, NULL);
		//PSHORT pSigBuf = PSHORT(buf_dscr.ppBlk[curbuf]);
		//LONG sum = 0;
		//for(ULONG j = 0; j < buf_dscr.blkSize/2; j++)
		//	sum += pSigBuf[j];
		//LONG mo = sum / buf_dscr.blkSize;
		curbuf ^= 1;
		if(cnt+1 != buf_dscr.pStub->totalCounter)
			errcnt++;
//			printf("ERROR: buffer %d skip\n", cnt);
		cnt = buf_dscr.pStub->totalCounter;
		if(i%4 == 0)
			printf("%s: Current buffer = %d\r", fileName, cnt);
//			printf("Current buffer = %d, MO = %d\r", cnt, mo);
	}
	Enable = 0;
	status = BRD_ctrl(hSrv, 0, BRDctrl_ADC_ENABLE, &Enable); //   
	if(g_MemAsFifo)
		status = BRD_ctrl(hSrv, 0, BRDctrl_SDRAM_ENABLE, &Enable); //    SDRAM
//	printf("                                             \r");
	if(errcnt)
		printf("ERROR (%s): buffers skiped %d\n", fileName, errcnt);
	printf("Total Buffer Counter (%s) = %d\n", fileName, buf_dscr.pStub->totalCounter);
	status = BRD_ctrl(hSrv, 0, BRDctrl_ADC_FIFOSTATUS, &Status);
	if(Status & 0x80)
		printf("ERROR (%s): ADC FIFO is overflow\n", fileName);

	status = BRD_ctrl(hSrv, 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
	delete[] buf_dscr.ppBlk;

	CloseHandle(hfile);
    _endthreadex( 0 );
	return status;
}
