//********************************************************
//
// Example Application for ADC service
//
// (C) InSys Jan, 2007
//
//********************************************************

#include	<windows.h>

#include	<stdio.h>
#include	<conio.h>
#include	<fcntl.h>
#include	<sys\stat.h>
#include	<share.h>
#include	<io.h>
#include	<tchar.h>
#include	<math.h>

#include	"adc_ctrl.h"

void GetOptions();
S32 SetParamSrv(BRD_Handle handle, BRD_ServList* srv, int idx);
S32 GetAdcData(BRD_Handle hADC, ULONG bBufSize, ULONG bMemBufSize);
//S32 GetDataFromSrv(BRD_Handle handle, BRD_ServList* srv, int idx);

S32	DataFromMemWriteFile(BRD_Handle hADC, PVOID pBuf, ULONG bBufSize, ULONG bMemBufSize, ULONG DmaOn);
//void WriteDataFile0(int idx, PVOID pBuf, ULONG nNumberOfBytes);
void WriteDataFile(BRD_Handle hADC, int idx, PVOID pBuf, ULONG nNumberOfBytes);
void WriteIsviParams(HANDLE hfile, BRD_Handle hADC, ULONG nNumberOfBytes);
void WriteFlagSinc(int flg, int isNewParam, int idx);
int ReadFlagSinc(int idx);

// Options
TCHAR g_AdcSrvName[32]; //   
TCHAR g_SrvName[32];	//   
TCHAR g_pldFileName[MAX_PATH];
int g_isPldLoadAlways = 1;

int g_times = 0;

ULONG g_DmaOn = 1;
ULONG g_Cycle = 0;
ULONG g_MemOn = 1;
ULONG g_IsWriteFile = 1;
ULONG g_IsSysMem = 0;
ULONG g_samplesOfChannel = 16384;
ULONG g_memorySamplesOfChannel = 16384;

ULONG DspMode = 0; //    
ULONG g_MemAsFifo = 0;

BRD_Handle g_hSRV;
ULONG g_bBufSize;
ULONG g_bMemBufSize;

void DirectFile(ULONG bufType, ULONG FileBufSize, ULONG FileBufNum);
void WriteIsviParamDirFile();
ULONG g_DirWriteFile;
ULONG g_FileBufSize;
char g_dirFileName[MAX_PATH] = "adcdir.bin";

//int g_PretrigMode = 0;
//__int64 g_nPreTrigSamples = 16;

char iniFileName[64] = "\\exam_adc.ini";

BRD_Info	g_info;

//=************************* main *************************
//=********************************************************
void main( int argc, char *argv[] )
{
	S32		status;

	// Parse Command Line
	if( argc > 1 )
	{
		lstrcpy(iniFileName, "\\");
		lstrcat(iniFileName, argv[1]);
	}
	fflush(stdout);
	setbuf(stdout, NULL);

	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	
	S32	DevNum;
	//status = BRD_initEx(BRDinit_AUTOINIT, "brd.ini", NULL, &DevNum); //   - 
	status = BRD_init("brd.ini", &DevNum); //  
	if( status < 0 )
	{
		printf( "ERROR: BARDY Initialization = 0x%X\n", status );
		return;
	}

	//   LID (   )
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	g_info.size = sizeof(g_info);
	BRD_Handle handle[10];

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &g_info); //    
		if(g_info.busType == BRDbus_ETHERNET)
			printf("%s, DevID = 0x%x, RevID = 0x%x, IP %u.%u.%u.%u, Port %u, PID = %d.\n", 
				g_info.name, g_info.boardType >> 16, g_info.boardType & 0xff,
				(UCHAR)g_info.bus, (UCHAR)(g_info.bus >> 8), (UCHAR)(g_info.bus >> 16), (UCHAR)(g_info.bus >> 24),
													g_info.dev, g_info.pid);
		else
			printf("%s, DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev = %d, Slot = %d, PID = %d.\n", 
				g_info.name, g_info.boardType >> 16, g_info.boardType & 0xff, g_info.bus, g_info.dev, g_info.slot, g_info.pid);
	}

	GetOptions();

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
//		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_EXCLUSIVE, NULL); //     
		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_SHARED, NULL); //     
		if(handle[iDev] > 0)
		{
			BRD_PuList PuList[10];
			U32 ItemReal;
			status = BRD_puList(handle[iDev], PuList, 10, &ItemReal); //    
			if(ItemReal <= 10)
			{
				for(U32 j = 0; j < ItemReal; j++)
				{
					if(PuList[j].puCode == PLD_CFG_TAG)
					{ //    - 
						printf("PU%d: %s, Id = %d, Code = %x, Attr = %x.\n",
										j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
						 //   
						U32	PldState;
						status = BRD_puState(handle[iDev], PuList[j].puId, &PldState);
						printf("BRD_puState: PldState = %d\n", PldState);
						if(PuList[j].puId == 0x100)
						{
							if(g_isPldLoadAlways || !PldState)
							{ //   ADM
								printf("BRD_puLoad: loading...\r");
								status = BRD_puLoad(handle[iDev], PuList[j].puId, g_pldFileName, &PldState);
								if(BRD_errcmp(status, BRDerr_OK))
									printf("BRD_puLoad: load is OK\n");
								else
									if(BRD_errcmp(status, BRDerr_PLD_TEST_DATA_ERROR))
										printf("BRD_puLoad: data error starting test\n");
									else
										if(BRD_errcmp(status, BRDerr_PLD_TEST_ADDRESS_ERROR))
											printf("BRD_puLoad: address error starting test\n");
										else
											printf("BRD_puLoad: error loading\n");
							}
						}
						else
						{  //   
							status = BRD_puLoad(handle[iDev], PuList[j].puId, "ambpcd_v10_dsp_test1.mcs", &PldState);
							if(BRD_errcmp(status, BRDerr_OK))
								printf("BRD_puLoad: load is OK\n");
							else
								printf("BRD_puLoad: error loading\n");
						}
					}
				}
			}
			if(BRD_errcmp(status, BRDerr_OK))
			{
				BRD_ServList srvList[10];
				status = BRD_serviceList(handle[iDev], 0, srvList, 10, &ItemReal);
				if(ItemReal <= 10)
				{
					//for(U32 j = 0; j < ItemReal; j++)
					//{
					//	printf("Service %d: %s, Attr = %X.\n",
					//					j, srvList[j].name, srvList[j].attr);
					//}
					U32 iSrv;
					for(iSrv = 0; iSrv < ItemReal; iSrv++)
					{
						if(!strcmp(srvList[iSrv].name, g_AdcSrvName))
							//status = GetDataFromSrv(handle[iDev], &srvList[iSrv], iDev * ItemReal + iSrv);
						{
							status = SetParamSrv(handle[iDev], &srvList[iSrv], iDev * ItemReal + iSrv);
							if(!BRD_errcmp(status, BRDerr_OK))
								break;
						}
					}
				}
				else
					printf("BRD_serviceList: Real Items = %d (> 10 - ERROR!!!)\n", ItemReal);
			}
		}
	}
	delete lidList.pLID;

	if(BRD_errcmp(status, BRDerr_OK))
	{
		if(g_DirWriteFile)
		{
				DirectFile(g_IsSysMem, g_FileBufSize, g_DirWriteFile);
				if(g_IsWriteFile == 1)
					WriteIsviParamDirFile();
		}
		else
			GetAdcData(g_hSRV, g_bBufSize, g_bMemBufSize);
	}
	status = BRD_release(g_hSRV, 0);

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		if(handle[iDev])
		{
			status = BRD_close(handle[iDev]); //   
			printf("BRD_close: OK\n");
		}
	}
	status = BRD_cleanup();
	printf("BRD_cleanup: OK\n");
	Sleep(2000);
//	printf("Press any key for leaving program...\n");
//	_getch();
}

//      ini-:
//    FileName -  ini- ( ,  )
//    SectionName -  
//    ParamName -   ()
//    defValue -   - (    )
//    strValue -  
//    strSize -   
static void GetInifileString(LPCTSTR FileName, LPCTSTR SectionName, LPCTSTR ParamName, LPSTR defValue, LPSTR strValue, int strSize)
{
	GetPrivateProfileString(SectionName, ParamName, defValue, strValue, strSize, FileName);
	TCHAR* pChar = _tcschr(strValue, ';');
	if(pChar) *pChar = 0; //    
	int str_size = lstrlen(strValue);
	for(int i = str_size - 1; i > 1; i--)
		if(strValue[i] != ' ' && strValue[i] != '\t')
		{
			strValue[i+1] = 0;
			break;
		}
}

void GetOptions()
{
	TCHAR Buffer[128];
	TCHAR iniFilePath[MAX_PATH];
	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);
	lstrcat(iniFilePath, iniFileName);
	//GetPrivateProfileString("Option", "AdcServiceName", "ADC212X200M", g_SrvName, sizeof(g_SrvName), iniFilePath);
	GetInifileString(iniFilePath, "Option", "AdcServiceName", "ADC212X200M", g_SrvName, sizeof(g_SrvName));
	sprintf(g_AdcSrvName, "%s%d", g_SrvName, 0);

	GetInifileString(iniFilePath, "Option", "PldFileName", "ambpcd_v10_adm212x200m.mcs", g_pldFileName, sizeof(g_pldFileName));
	//GetPrivateProfileString("Option", "PldFileName", "ambpcd_v10_adm212x200m.mcs", g_pldFileName, sizeof(g_pldFileName), iniFilePath);

	GetPrivateProfileString("Option", "isPldLoadAlways", "1", Buffer, sizeof(Buffer), iniFilePath);
	g_isPldLoadAlways = atoi(Buffer);
	GetPrivateProfileString("Option", "BusMasterEnable", "1", Buffer, sizeof(Buffer), iniFilePath);
	g_DmaOn = atoi(Buffer);
	GetPrivateProfileString("Option", "Cycle", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_Cycle = atoi(Buffer);
	GetPrivateProfileString("Option", "DaqIntoMemory", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_MemOn = atoi(Buffer);
	GetPrivateProfileString("Option", "IsWriteFile", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_IsWriteFile = atoi(Buffer);
	GetPrivateProfileString("Option", "SamplesPerChannel", "10240", Buffer, sizeof(Buffer), iniFilePath);
	g_samplesOfChannel = atoi(Buffer);
	GetPrivateProfileString("Option", "MemSamplesPerChan", "10240", Buffer, sizeof(Buffer), iniFilePath);
	g_memorySamplesOfChannel = atoi(Buffer);
	GetPrivateProfileString("Option", "IsSystemMemory", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_IsSysMem = atoi(Buffer);
	if(g_IsSysMem == 1 && g_info.busType == BRDbus_ETHERNET)
	{
		printf("Ethernet: IsSystemMemory=0 or IsSystemMemory=2 (NOT EQUAL 1)!!!\n");		
		g_IsSysMem = 0;
	}
	GetPrivateProfileString("Option", "DirFileBufSize", "64", Buffer, sizeof(Buffer), iniFilePath); // KBytes
	g_FileBufSize = atoi(Buffer) * 1024;
	GetPrivateProfileString("Option", "DirNumBufWrite", "0", Buffer, sizeof(Buffer), iniFilePath); // KBytes
	g_DirWriteFile = atoi(Buffer);
	GetInifileString(iniFilePath, "Option", "DirFileName", "adcdir.bin", g_dirFileName, sizeof(g_dirFileName));
}

S32 SetParamSrv(BRD_Handle handle, BRD_ServList* srv, int idx)
{
	S32		status;
	U32 mode = BRDcapt_EXCLUSIVE;
	BRD_Handle hADC = BRD_capture(handle, 0, &mode, srv->name, 10000);
	if(mode == BRDcapt_EXCLUSIVE) printf("ADC Capture mode: EXCLUSIVE\n");
	if(mode == BRDcapt_SPY)	printf("ADC Capture mode: SPY\n");
	if(hADC > 0)
	{
		//g_hSRV[g_nSrv++] = hADC;
		g_hSRV = hADC;

		int numChan = AdcSettings(hADC, 0, g_SrvName, iniFileName); //   
//		int numChan = AdcSettings(hADC, 0); //   

		ULONG format = 0;
		BRD_ctrl(hADC, 0, BRDctrl_ADC_GETFORMAT, &format);
		ULONG sample_size = format ? format : sizeof(short);

		g_bBufSize = (g_samplesOfChannel * numChan) * sample_size; //      

		if(!g_DirWriteFile)
			printf("SamplesPerChannel = %d (%d kBytes)\n", g_samplesOfChannel, g_bBufSize/1024);

		g_bMemBufSize = (g_memorySamplesOfChannel * numChan) * sample_size; //        

		//    
		BRD_SdramCfg SdramConfig;
		ULONG PhysMemSize;
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETCFG, &SdramConfig);
		if(status < 0)
		{
			PhysMemSize = 0;
			return BRDerr_OK;
		}
		else
			PhysMemSize =	(1 << SdramConfig.RowAddrBits) *
							(1 << SdramConfig.ColAddrBits) * 
							SdramConfig.ModuleBanks * 
							SdramConfig.ChipBanks *
							SdramConfig.ModuleCnt * 2; //  32- 

		if(PhysMemSize && g_MemOn)
		{ //     
			printf("SDRAM Config: Memory size = %d MBytes\n", (PhysMemSize / (1024 * 1024)) * 4);

			status = SdramSettings(g_MemOn, hADC, g_bMemBufSize); //   SDRAM
			g_memorySamplesOfChannel = (g_bMemBufSize / sample_size) / numChan;
			if(g_MemOn == 2)
			{
				printf("SDRAM as a FIFO mode!!!\n");
				g_MemOn = 0;
				g_MemAsFifo = 1;
			}
			else
				printf("Samples of channel = %d\n", g_memorySamplesOfChannel);

		}
		else
		{
			 //   SDRAM (     BRDctrl_SDRAM_GETCFG,     )
			ULONG mem_size = 0;
			status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_SETMEMSIZE, &mem_size);

			//          
			//ULONG DspMode = 1;
			//status = BRD_ctrl(hADC, 0, BRDctrl_DSPNODE_SETMODE, &DspMode);
			//if(status < 0) //     
			//	DspMode = 0;

		}
	}
	return status;
}

S32 GetAdcData(BRD_Handle hADC, ULONG bBufSize, ULONG bMemBufSize)
{
	S32		status;
	int idx = 0;

	PVOID pSig = NULL;
	if(g_DmaOn)
	{
		if(!g_Cycle)
			printf("AllocDaqBuf\n");
		status = AllocDaqBuf(hADC, &pSig, &bBufSize, g_IsSysMem);
		if(!BRD_errcmp(status, BRDerr_OK))
			return status;
		if(!pSig)
		{
			printf("ERROR: Buffer NOT allocate!!!\n");
			return status;
		}
	}
	else
		pSig = new char[bBufSize];
	if(!g_Cycle)
	{ //   
		if(!g_DmaOn)
		{ //   
			if(g_MemOn)
			{ //       
				//status = DaqIntoSdram(hADC, pSig, bBufSize, numChan); //   
				status = DaqIntoSdram(hADC); //     
				status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
			}
			else
			{ //   FIFO    
				status = DaqIntoFifo(hADC, pSig, bBufSize, DspMode); //   
				WriteDataFile(hADC, 0, pSig, bBufSize);
			}
//				WriteDataFile(hADC, idx, pSig, bBufSize);
		}
		else
		{ // - 
			if(g_MemOn)
			{ //     - 
				printf("DAQ into SDRAM\n");
				//status = DaqIntoSdramDMA(hADC, idx, bBufSize, numChan); //   
				status = DaqIntoSdramDMA(hADC); //   
				if(status != -1)
					status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
			}
			else
			{ //   FIFO  - 
				printf("DAQ into FIFO\n");
				status = DaqIntoFifoDMA(hADC, idx, bBufSize, DspMode); //   
				WriteDataFile(hADC, 0, pSig, bBufSize);
			}
		}
	}
	else
	{ //  ()  
		if(g_IsWriteFile)
			WriteFlagSinc(0, 0, 0);
//				WriteFlagSinc(0, 0, idx);
		printf("\n\n");
		int loop = 0;
		int newParam_fl = 0xffffffff;
		do
		{
//				printf("Send Loop: [0x%08lX]\r", loop );
			printf("Send Loop: [%08ld]\r", loop );
			if(!g_DmaOn)
			{ //   
				if(g_MemOn)
				{ //       
					//status = DaqIntoSdram(hADC, pSig, bBufSize, numChan); //   
					status = DaqIntoSdram(hADC); //     
					status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
				}
				else
				{ //   FIFO    
					status = DaqIntoFifo(hADC, pSig, bBufSize, DspMode); //   
					WriteDataFile(hADC, 0, pSig, bBufSize);
				}
//					WriteDataFile(hADC, idx, pSig, bBufSize);
			}
			else
			{ //     - 
				if(g_MemOn)
				{ //     - 
					status = StartDaqIntoSdramDMA(hADC, idx); //   
					while(!CheckDaqIntoSdramDMA()) //    
					{
						if(_kbhit()) //     
						{
							int ch = _getch(); //  
							if(0x1B == ch) //  Esc
							{
								BreakDaqIntoSdramDMA(); // //   
								loop = -1;
							}
						}
					}
					EndDaqIntoSdramDMA(); //    (Handles)
					if(loop != -1)
						status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
//						status = DaqIntoSdramDMA(hADC, idx, bBufSize, numChan); //   
				}
				else
				{ //   FIFO  - 
					status = DaqIntoFifoDMA(hADC, idx, bBufSize, DspMode); //   
					if(loop != -1)
						WriteDataFile(hADC, 0, pSig, bBufSize);
				}
				//WriteDataFile(hADC, idx, g_buf_dscr.ppBlk[0], bBufSize);
				//WriteDataFile0(idx, buf_dscr.ppBlk[0], bBufSize);
			}
			if(loop == -1)
				break;
			if(g_IsWriteFile)
			{
				if(g_Cycle <= 1)
					WriteFlagSinc(0xffffffff, newParam_fl, 0);
				if(g_Cycle > 1 && g_times == g_Cycle)
					WriteFlagSinc(0xffffffff, 0xffffffff, 0);
				//WriteFlagSinc(0xffffffff, newParam_fl, idx);
				loop++;
				int rd_idx = 0;
				newParam_fl = 0;
				do
				{
					int rd_fl = ReadFlagSinc(0);
//						int rd_fl = ReadFlagSinc(idx);
					if(_kbhit())
					{
						int ch = _getch();
						if(0x1B == ch) 
							loop = 0;
						if(0x20 == ch)
						{
							status = AdcSettings(hADC, 0, g_SrvName, iniFileName); //   
							newParam_fl = 0xffffffff;
						}
					}
					if(rd_fl == 0)
						break;
					if(rd_fl == 0xffffffff && rd_idx>0x1000 )
						break;
					rd_idx++;
				}while(loop);
			}
			else
			{
				loop++;
				if(_kbhit())
					if(0x1B == _getch()) 
						loop = 0;
			}
			if(g_Cycle > 1 && loop == g_Cycle)
				break;
		}while(loop);
	}
	if(g_DmaOn)
		status = FreeDaqBuf(hADC);
	else
		delete pSig;

	return status;
}

/*
S32 GetDataFromSrv(BRD_Handle handle, BRD_ServList* srv, int idx)
{
	S32		status;
	U32 mode = BRDcapt_EXCLUSIVE;
	BRD_Handle hADC = BRD_capture(handle, 0, &mode, srv->name, 10000);
	if(mode == BRDcapt_EXCLUSIVE) printf("ADC Capture mode: EXCLUSIVE\n");
	if(mode == BRDcapt_SPY)	printf("ADC Capture mode: SPY\n");
	if(hADC > 0)
	{
		int numChan = AdcSettings(hADC, 0, g_SrvName, iniFileName); //   
//		int numChan = AdcSettings(hADC, 0); //   

		ULONG format = 0;
		BRD_ctrl(hADC, 0, BRDctrl_ADC_GETFORMAT, &format);
		ULONG sample_size = format ? format : sizeof(short);

		ULONG bBufSize = (g_samplesOfChannel * numChan) * sample_size; //      

		printf("SamplesPerChannel = %d (%d kBytes)\n", g_samplesOfChannel, bBufSize/1024);

		ULONG bMemBufSize = (g_memorySamplesOfChannel * numChan) * sample_size; //        

		ULONG DspMode = 0; //    

		//    
		BRD_SdramCfg SdramConfig;
		ULONG PhysMemSize;
		status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_GETCFG, &SdramConfig);
		if(status < 0)
			PhysMemSize = 0;
		else
			PhysMemSize =	(1 << SdramConfig.RowAddrBits) *
							(1 << SdramConfig.ColAddrBits) * 
							SdramConfig.ModuleBanks * 
							SdramConfig.ChipBanks *
							SdramConfig.ModuleCnt * 2; //  32- 

		if(PhysMemSize && g_MemOn)
		{ //     
			printf("SDRAM Config: Memory size = %d MBytes\n", (PhysMemSize / (1024 * 1024)) * 4);

			status = SdramSettings(hADC, bMemBufSize); //   SDRAM
			g_memorySamplesOfChannel = (bMemBufSize / sample_size) / numChan;
			printf("Samples of channel = %d\n", g_memorySamplesOfChannel);
		}
		else
		{
			 //   SDRAM (     BRDctrl_SDRAM_GETCFG,     )
			ULONG mem_size = 0;
			status = BRD_ctrl(hADC, 0, BRDctrl_SDRAM_SETMEMSIZE, &mem_size);

			//          
			//ULONG DspMode = 1;
			//status = BRD_ctrl(hADC, 0, BRDctrl_DSPNODE_SETMODE, &DspMode);
			//if(status < 0) //     
			//	DspMode = 0;

		}

		PVOID pSig = NULL;
		if(g_DmaOn)
		{
			if(!g_Cycle)
				printf("AllocDaqBuf\n");
			status = AllocDaqBuf(hADC, &pSig, &bBufSize, g_IsSysMem);
			if(!BRD_errcmp(status, BRDerr_OK))
				return status;
			if(!pSig)
			{
				printf("ERROR: Buffer NOT allocate!!!\n");
				return status;
			}
		}
		else
			pSig = new char[bBufSize];
		if(!g_Cycle)
		{ //   
			if(!g_DmaOn)
			{ //   
				if(g_MemOn)
				{ //       
					//status = DaqIntoSdram(hADC, pSig, bBufSize, numChan); //   
					status = DaqIntoSdram(hADC); //     
					status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
				}
				else
				{ //   FIFO    
					status = DaqIntoFifo(hADC, pSig, bBufSize, numChan, DspMode); //   
					WriteDataFile(hADC, 0, pSig, bBufSize);
				}
//				WriteDataFile(hADC, idx, pSig, bBufSize);
			}
			else
			{ // - 
				if(g_MemOn)
				{ //     - 
					printf("DAQ into SDRAM\n");
					//status = DaqIntoSdramDMA(hADC, idx, bBufSize, numChan); //   
					status = DaqIntoSdramDMA(hADC); //   
					if(status != -1)
						status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
				}
				else
				{ //   FIFO  - 
					printf("DAQ into FIFO\n");
					status = DaqIntoFifoDMA(hADC, idx, bBufSize, numChan, DspMode); //   
					WriteDataFile(hADC, 0, pSig, bBufSize);
				}
			}
		}
		else
		{ //  ()  
			if(g_IsWriteFile)
				WriteFlagSinc(0, 0, 0);
//				WriteFlagSinc(0, 0, idx);
			printf("\n\n");
			int loop = 0;
			int newParam_fl = 0xffffffff;
			do
			{
//				printf("Send Loop: [0x%08lX]\r", loop );
				printf("Send Loop: [%08ld]\r", loop );
				if(!g_DmaOn)
				{ //   
					if(g_MemOn)
					{ //       
						//status = DaqIntoSdram(hADC, pSig, bBufSize, numChan); //   
						status = DaqIntoSdram(hADC); //     
						status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
					}
					else
					{ //   FIFO    
						status = DaqIntoFifo(hADC, pSig, bBufSize, numChan, DspMode); //   
						WriteDataFile(hADC, 0, pSig, bBufSize);
					}
//					WriteDataFile(hADC, idx, pSig, bBufSize);
				}
				else
				{ //     - 
					if(g_MemOn)
					{ //     - 
						status = StartDaqIntoSdramDMA(hADC, idx); //   
						while(!CheckDaqIntoSdramDMA()) //    
						{
							if(_kbhit()) //     
							{
								int ch = _getch(); //  
								if(0x1B == ch) //  Esc
								{
									BreakDaqIntoSdramDMA(); // //   
									loop = -1;
								}
							}
						}
						EndDaqIntoSdramDMA(); //    (Handles)
						if(loop != -1)
							status = DataFromMemWriteFile(hADC, pSig, bBufSize, bMemBufSize, g_DmaOn); //       ,    
//						status = DaqIntoSdramDMA(hADC, idx, bBufSize, numChan); //   
					}
					else
					{ //   FIFO  - 
						status = DaqIntoFifoDMA(hADC, idx, bBufSize, numChan, DspMode); //   
						if(loop != -1)
							WriteDataFile(hADC, 0, pSig, bBufSize);
					}
					//WriteDataFile(hADC, idx, g_buf_dscr.ppBlk[0], bBufSize);
					//WriteDataFile0(idx, buf_dscr.ppBlk[0], bBufSize);
				}
				if(loop == -1)
					break;
				if(g_IsWriteFile)
				{
					if(g_Cycle <= 1)
						WriteFlagSinc(0xffffffff, newParam_fl, 0);
					if(g_Cycle > 1 && g_times == g_Cycle)
						WriteFlagSinc(0xffffffff, 0xffffffff, 0);
					//WriteFlagSinc(0xffffffff, newParam_fl, idx);
					loop++;
					int rd_idx = 0;
					newParam_fl = 0;
					do
					{
						int rd_fl = ReadFlagSinc(0);
//						int rd_fl = ReadFlagSinc(idx);
						if(_kbhit())
						{
							int ch = _getch();
							if(0x1B == ch) 
								loop = 0;
							if(0x20 == ch)
							{
								status = AdcSettings(hADC, 0, g_SrvName, iniFileName); //   
								newParam_fl = 0xffffffff;
							}
						}
						if(rd_fl == 0)
							break;
						if(rd_fl == 0xffffffff && rd_idx>0x1000 )
							break;
						rd_idx++;
					}while(loop);
				}
				else
				{
					loop++;
					if(_kbhit())
						if(0x1B == _getch()) 
							loop = 0;
				}
				if(g_Cycle > 1 && loop == g_Cycle)
					break;
			}while(loop);
		}
		if(g_DmaOn)
			status = FreeDaqBuf(hADC);
		else
			delete pSig;

		status = BRD_release(hADC, 0);
	}
	return status;
}
*/
S32	DataFromMemWriteFile(BRD_Handle hADC, PVOID pBuf, ULONG bBufSize, ULONG bMemBufSize, ULONG DmaOn)
{
	S32	status;
	if(!g_IsWriteFile)
		return 1;
	if(!g_Cycle)
		printf("Writing file...\n");

	TCHAR fileName[64];
	sprintf(fileName, "data_%d.bin", 0);

	HANDLE hfile = CreateFile(	fileName,
								GENERIC_WRITE,
								FILE_SHARE_WRITE | FILE_SHARE_READ,
								NULL,
								CREATE_ALWAYS,
								FILE_ATTRIBUTE_NORMAL,
								NULL);
	if(hfile == INVALID_HANDLE_VALUE)
	{
		printf("Create file %s error.\n", fileName);
		return 1;
	}
	ULONG nNumberOfWriteBytes;
	BOOL bResult = TRUE;

	int nCnt = bMemBufSize / bBufSize;
	for(int iCnt = 0; iCnt < nCnt; iCnt++)
	{
		status = DataFromMem(hADC, pBuf, bBufSize, DmaOn);
		bResult = WriteFile(hfile, pBuf, bBufSize, &nNumberOfWriteBytes, NULL);
	}
	ULONG ostSize = bMemBufSize % bBufSize;
	if(ostSize)
	{
		status = DataFromMem(hADC, pBuf, bBufSize, DmaOn);
		bResult = WriteFile(hfile, pBuf, ostSize, &nNumberOfWriteBytes, NULL);
	}

	if(g_IsWriteFile == 1)
		WriteIsviParams(hfile, hADC, bMemBufSize);

	CloseHandle(hfile);
	if(bResult != TRUE)
		printf("Write file %s error.\n", fileName);
	else
		if(!g_Cycle)
			printf("Write file %s is OK.\n", fileName);
	return status;
}

void WriteDataFile(BRD_Handle hADC, int idx, PVOID pBuf, ULONG nNumberOfBytes)
{
	if(!g_IsWriteFile)
		return;
	if(!g_Cycle)
		printf("Writing file...\n");

	TCHAR fileName[64];
	sprintf(fileName, "data_%d.bin", idx);
	HANDLE hfile = INVALID_HANDLE_VALUE;
	if(g_Cycle > 1 && g_times)
	{	
		hfile = CreateFile(	fileName,
								GENERIC_WRITE,
								FILE_SHARE_WRITE | FILE_SHARE_READ,
								NULL,
								OPEN_EXISTING,
								FILE_ATTRIBUTE_NORMAL,
								NULL);
		LONG HiPart = 0;
		SetFilePointer(hfile, 0, &HiPart, FILE_END);
	}
	else
	{
		hfile = CreateFile(	fileName,
								GENERIC_WRITE,
								FILE_SHARE_WRITE | FILE_SHARE_READ,
								NULL,
								CREATE_ALWAYS,
								FILE_ATTRIBUTE_NORMAL,
								NULL);
	}
	g_times++;
	if(hfile == INVALID_HANDLE_VALUE)
	{
		printf("Create file %s error.\n", fileName);
		return;
	}

	ULONG nNumberOfWriteBytes;
	BOOL bResult = WriteFile(hfile, pBuf, nNumberOfBytes, &nNumberOfWriteBytes, NULL);

	if(g_IsWriteFile == 1)
		if((g_Cycle > 1 && g_times == g_Cycle) || g_Cycle <= 1)
			WriteIsviParams(hfile, hADC, nNumberOfBytes);

	CloseHandle(hfile);
	if(bResult != TRUE)
		printf("Write file %s error.\n", fileName);
	else
		if(!g_Cycle)
			printf("Write file %s is OK.\n", fileName);
}

void WriteIsviParamDirFile()
{
	TCHAR fileName[MAX_PATH];

	lstrcpy(fileName, g_dirFileName);

	HANDLE hfile = CreateFile(	fileName,
								GENERIC_READ | GENERIC_WRITE,
								FILE_SHARE_WRITE | FILE_SHARE_READ,
								NULL,
								OPEN_EXISTING,
								FILE_ATTRIBUTE_NORMAL,
								NULL);
	if(hfile == INVALID_HANDLE_VALUE)
	{
		printf("Create file %s error.\n", fileName);
		return;
	}
	long lDistanceToMoveLow = 0L;
	long lDistanceToMoveHigh = 0L;
	ULONG BytesNum = SetFilePointer(hfile, lDistanceToMoveLow, &lDistanceToMoveHigh, FILE_END);

	if(lDistanceToMoveHigh)
		printf("File %s is too big for ISVI parameters writing.\n", fileName);
	else
		WriteIsviParams(hfile, g_hSRV, BytesNum);
	CloseHandle(hfile);
}

void WriteIsviParams(HANDLE hfile, BRD_Handle hADC, ULONG nNumberOfBytes)
{
	char	fileInfo[2048];
	char    str_buf[512];

    sprintf(fileInfo, "\r\nDEVICE_NAME_________ " );
    lstrcat(fileInfo, g_AdcSrvName);

	BRD_AdcCfg adc_cfg;
	BRD_ctrl(hADC, 0, BRDctrl_ADC_GETCFG, &adc_cfg);
	double samplRate;
	BRD_ctrl(hADC, 0, BRDctrl_ADC_GETRATE, &samplRate);
	ULONG chanMask;
	BRD_ctrl(hADC, 0, BRDctrl_ADC_GETCHANMASK, &chanMask);
	ULONG format = 0;
	BRD_ctrl(hADC, 0, BRDctrl_ADC_GETFORMAT, &format);

	ULONG is_complex = 0;

	int num_chan = 0;
	int	chans[MAX_CHAN];
	double gains[MAX_CHAN];
	double volt_offset[MAX_CHAN];
	ULONG mask = 1;
	BRD_ValChan val_chan;
	for(ULONG iChan = 0; iChan < adc_cfg.NumChans; iChan++)
	{
		if(chanMask & mask)
			chans[num_chan++] = iChan;
		val_chan.chan = iChan;
		BRD_ctrl(hADC, 0, BRDctrl_ADC_GETGAIN, &val_chan);
		if(adc_cfg.ChanType == 1)
			val_chan.value = pow(10., val_chan.value/20); // dB -> 
		gains[iChan] = val_chan.value;
		volt_offset[iChan] = 0.0;
		mask <<= 1;
	}
	sprintf(str_buf, "\r\nNUMBER_OF_CHANNELS__ %d", num_chan);
    lstrcat(fileInfo, str_buf);

	sprintf(str_buf, "\r\nNUMBERS_OF_CHANNELS_ ");
    lstrcat(fileInfo, str_buf);
	str_buf[0] = 0;
	for(int iChan = 0; iChan < num_chan; iChan++)
	{
		char buf[16];
		sprintf(buf, "%d,", chans[iChan]);
		lstrcat(str_buf, buf);
	}
    lstrcat(fileInfo, str_buf);

	ULONG sample_size = format ? format : sizeof(short);
	ULONG samples = nNumberOfBytes / sample_size / num_chan;
	if(g_Cycle > 1)
		 samples *= g_Cycle;
    sprintf(str_buf, "\r\nNUMBER_OF_SAMPLES___ %d", samples );
    lstrcat(fileInfo, str_buf);

    sprintf(str_buf, "\r\nSAMPLING_RATE_______ %f", samplRate );
    lstrcat(fileInfo, str_buf);

    sprintf(str_buf, "\r\nBYTES_PER_SAMPLES___ %d", sample_size);
    lstrcat(fileInfo, str_buf);

    lstrcat(fileInfo, "\r\nSAMPLES_PER_BYTES___ 1");

	if(is_complex)
	    sprintf(str_buf, "\r\nIS_COMPLEX_SIGNAL?__ YES");
	else
	    sprintf(str_buf, "\r\nIS_COMPLEX_SIGNAL?__ NO");
    lstrcat(fileInfo, str_buf);

	//double fc[MAX_CHAN];
	sprintf(str_buf, "\r\nSHIFT_FREQUENCY_____ ");
    lstrcat(fileInfo, str_buf);
	str_buf[0] = 0;
	int num_fc = num_chan;
	for(int iChan = 0; iChan < num_fc; iChan++)
	{
		//char buf[16];
		//fc[iChan] = 0.0;
		//sprintf(buf, "%.2f,", fc[iChan]);
		//lstrcat(str_buf, buf);
		lstrcat(str_buf, "0.0,");
	}
    lstrcat(fileInfo, str_buf);

	sprintf(str_buf, "\r\nGAINS_______________ ");
    lstrcat(fileInfo, str_buf);
	str_buf[0] = 0;
	for(int iChan = 0; iChan < num_chan; iChan++)
	{
		char buf[16];
		sprintf(buf,"%f,", gains[chans[iChan]]);
		lstrcat(str_buf, buf);
	}
    lstrcat(fileInfo, str_buf);

	sprintf(str_buf, "\r\nVOLTAGE_OFFSETS_____ ");
    lstrcat(fileInfo, str_buf);
	str_buf[0] = 0;
	for(int iChan = 0; iChan < num_chan; iChan++)
	{
		char buf[16];
		sprintf(buf,"%f,", volt_offset[iChan]);
		lstrcat(str_buf, buf);
	}
    lstrcat(fileInfo, str_buf);

    sprintf(str_buf, "\r\nVOLTAGE_RANGE_______ %f", adc_cfg.InpRange / 1000.);
    lstrcat(fileInfo, str_buf);

//	int BitsPerSample = !format ? adc_cfg.Bits : 8;
//	if(is_complex)
//		BitsPerSample = 16;
	int BitsPerSample = (format == 1) ? 8 : adc_cfg.Bits;
	if(strstr(g_AdcSrvName, "ADC1624X192") || strstr(g_AdcSrvName, "ADC818X800"))
		if(format == 0 || format == 2)
			BitsPerSample = 16;
    sprintf(str_buf, "\r\nBIT_RANGE___________ %d", BitsPerSample);
    lstrcat(fileInfo, str_buf);
    lstrcat(fileInfo, "\r\n");

	int len = lstrlen(fileInfo);

	ULONG nNumberOfWriteBytes;
	BOOL bResult = WriteFile(hfile, fileInfo, len, &nNumberOfWriteBytes, NULL);
	if(bResult != TRUE)
		printf("Write ISVI info error\n");

}

//********************************************************
void WriteFlagSinc(int flg, int isNewParam, int idx)
{
    int fs = -1;
    int val[2];

	TCHAR fileName[64];
	sprintf(fileName, "data_%d.flg", idx);
    while(fs == -1)
        fs = _sopen(fileName, _O_WRONLY|_O_BINARY|_O_CREAT|_O_TRUNC, _SH_DENYNO, _S_IWRITE);
//    errno_t err = _sopen_s( &fs, fileName, _O_WRONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IWRITE );
    val[0] = flg;
    val[1] = isNewParam;
    _write(fs, val, 8);
    _close(fs);
}

//********************************************************
int ReadFlagSinc(int idx)
{
    int fs = -1;
	int flg;

	TCHAR fileName[64];
	sprintf(fileName, "data_%d.flg", idx);
    while(fs == -1)
        fs = _sopen(fileName, _O_RDONLY|_O_BINARY, _SH_DENYNO, _S_IREAD);
//    errno_t err = _sopen_s( &fs, fileName, _O_RDONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IREAD );
	_read(fs,&flg,4);
	_close(fs);
    return flg;
}
////********************************************************
//void WriteFlagSinc(int flg, int isNewParam, int idx)
//{
//    int fs;
//    int val[2];
//
//	TCHAR fileName[64];
//	sprintf(fileName, "data_%d.flg", idx);
////    fs = _open( fileName, O_RDWR|O_BINARY|O_CREAT, S_IREAD|S_IWRITE );
//    errno_t err = _sopen_s( &fs, fileName, _O_WRONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IWRITE );
////    fs = open( fileName, O_RDWR|O_BINARY|O_CREAT, S_IREAD|S_IWRITE );
//    val[0]=flg;
//    val[1]=isNewParam;
//    _write(fs,val,8);
//    _close(fs);
//}
//
////********************************************************
//int ReadFlagSinc(int idx)
//{
//    int fs,flg;
//	TCHAR fileName[64];
//	sprintf(fileName, "data_%d.flg", idx);
////    fs = open( fileName, O_DENYNONE|O_RDWR|O_BINARY|O_CREAT, S_IREAD|S_IWRITE );
////    errno_t err = _sopen( &fs, fileName, _O_RDONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IREAD );
//    errno_t err = _sopen_s( &fs, fileName, _O_RDONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IREAD );
//	_read(fs,&flg,4);
//	_close(fs);
////    fs = open( fileName, O_RDWR|O_BINARY|O_CREAT, S_IREAD|S_IWRITE );
////    read(fs,&flg,4);
////	close(fs);
//    return flg;
//}

//
// End of file
//
