//********************************************************
//
// Example Application of BRD_xxx functions for DAC services.
//
// (C) InSys by Dorokhin Andrey Jun, 2007
//
// 
//
//=********************************************************

#include	<windows.h>
#include	<stdio.h>
#include	<conio.h>
#include	<fcntl.h>
#include	<sys\stat.h>
#include	<share.h>
#include	<io.h>
#include	<tchar.h>

#include	"dac_ctrl.h"

void GetOptions();
S32 PutDataToSrv(BRD_Handle handle, BRD_ServList* srv, int idx);

void WriteDataFile(int idx, PVOID pBuf, ULONG nNumberOfBytes);

// Options
TCHAR g_DacSrvName[32]; //   
TCHAR g_SrvName[32];	//   
TCHAR g_pldFileName[MAX_PATH];
int g_isPldLoadAlways = 1;

ULONG g_DmaOn = 1;
ULONG g_Cycle = 0;
ULONG g_IsReadFile = 1;
ULONG g_WriteFile = 0;
ULONG g_IsSysMem = 0;
ULONG g_samplesOfChannel = 16384;
double g_SignalFreq = 100.0;
ULONG g_NumberOfPeriod = 1;
double g_Amplitude[16];
ULONG g_FreqDivider[16];

char iniFileName[] = "\\exam_dac.ini";

BRD_Info	g_info;

//=************************* main *************************
//=********************************************************
void main( int argc, char *argv[] )
{
	S32		status;

//	FILE* fin = fopen( "brd.ini", "rt" );
//	fclose(fin);
	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	
	S32	DevNum;
	status = BRD_init("brd.ini", &DevNum); //  
//	BRD_Error* pErrInfo = NULL;
//	status = BRD_error(&pErrInfo); //    

	//   LID (   )
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	g_info.size = sizeof(g_info);
	BRD_Handle handle[10];

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &g_info); //    
		if(g_info.busType == BRDbus_ETHERNET)
			printf("%s, DevID = 0x%x, RevID = 0x%x, IP %u.%u.%u.%u, Port %u, PID = %d.\n", 
				g_info.name, g_info.boardType >> 16, g_info.boardType & 0xff,
				(UCHAR)g_info.bus, (UCHAR)(g_info.bus >> 8), (UCHAR)(g_info.bus >> 16), (UCHAR)(g_info.bus >> 24),
													g_info.dev, g_info.pid);
		else
			printf("%s, DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev = %d, Slot = %d, PID = %d.\n", 
				g_info.name, g_info.boardType >> 16, g_info.boardType & 0xff, g_info.bus, g_info.dev, g_info.slot, g_info.pid);
	}

	GetOptions();

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
//		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_EXCLUSIVE, NULL); //     
		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_SHARED, NULL); //     
		if(handle[iDev] > 0)
		{
			BRD_PuList PuList[5];
			U32 ItemReal;
			status = BRD_puList(handle[iDev], PuList, 5, &ItemReal); //    
			if(ItemReal <= 5)
			{
				for(U32 j = 0; j < ItemReal; j++)
				{
					if(PuList[j].puCode == PLD_CFG_TAG)
					{ //    - 
						printf("PU%d: %s, Id = %d, Code = %x, Attr = %x.\n",
										j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
						 //   
						U32	PldState;
						status = BRD_puState(handle[iDev], PuList[j].puId, &PldState);
						printf("BRD_puState: PldState = %d\n", PldState);
						if(PuList[j].puId == 0x100)
						{
							if(g_isPldLoadAlways || !PldState)
							{ //   ADM
								printf("BRD_puLoad: loading...\r");
								status = BRD_puLoad(handle[iDev], PuList[j].puId, g_pldFileName, &PldState);
								if(BRD_errcmp(status, BRDerr_OK))
									printf("BRD_puLoad: load is OK\n");
								else
									if(BRD_errcmp(status, BRDerr_PLD_TEST_DATA_ERROR))
										printf("BRD_puLoad: data error starting test\n");
									else
										if(BRD_errcmp(status, BRDerr_PLD_TEST_ADDRESS_ERROR))
											printf("BRD_puLoad: address error starting test\n");
										else
											printf("BRD_puLoad: error loading\n");
							}
						}
						else
						{  //   
							status = BRD_puLoad(handle[iDev], PuList[j].puId, "ambpcd_v10_dsp_test1.mcs", &PldState);
							if(BRD_errcmp(status, BRDerr_OK))
								printf("BRD_puLoad: load is OK\n");
							else
								printf("BRD_puLoad: error loading\n");
						}
					}
				}
			}
			if(BRD_errcmp(status, BRDerr_OK))
			{
				BRD_ServList srvList[10];
				status = BRD_serviceList(handle[iDev], 0, srvList, 10, &ItemReal);
				if(ItemReal <= 10)
				{
					//for(U32 j = 0; j < ItemReal; j++)
					//{
					//	printf("Service %d: %s, Attr = %X.\n",
					//					j, srvList[j].name, srvList[j].attr);
					//}
					U32 iSrv;
					for(iSrv = 0; iSrv < ItemReal; iSrv++)
					{
						if(!strcmp(srvList[iSrv].name, g_DacSrvName))
							status = PutDataToSrv(handle[iDev], &srvList[iSrv], iDev * ItemReal + iSrv);
					}
				}
				else
					printf("BRD_serviceList: Real Items = %d (> 10 - ERROR!!!)\n", ItemReal);
			}
		}
	}
	delete lidList.pLID;
	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		if(handle[iDev])
		{
			status = BRD_close(handle[iDev]); //   
			printf("BRD_close: OK\n");
		}
	}
	status = BRD_cleanup();
	printf("BRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();
}

//      ini-:
//    FileName -  ini- ( ,  )
//    SectionName -  
//    ParamName -   ()
//    defValue -   - (    )
//    strValue -  
//    strSize -   
static void GetInifileString(LPCTSTR FileName, LPCTSTR SectionName, LPCTSTR ParamName, LPSTR defValue, LPSTR strValue, int strSize)
{
	GetPrivateProfileString(SectionName, ParamName, defValue, strValue, strSize, FileName);
	TCHAR* pChar = _tcschr(strValue, ';');
	if(pChar) *pChar = 0; //    
	int str_size = lstrlen(strValue);
	for(int i = str_size - 1; i > 1; i--)
		if(strValue[i] != ' ' && strValue[i] != '\t')
		{
			strValue[i+1] = 0;
			break;
		}
}

void GetOptions()
{
	TCHAR Buffer[128];
	TCHAR ParamName[128];
	TCHAR iniFilePath[MAX_PATH];
	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);
	lstrcat(iniFilePath, iniFileName);
	//GetPrivateProfileString("Option", "DacServiceName", "DAC1624X192", g_SrvName, sizeof(g_DacSrvName), iniFilePath);
	GetInifileString(iniFilePath, "Option", "DacServiceName", "DAC1624X192", g_SrvName, sizeof(g_SrvName));
	sprintf_s(g_DacSrvName, "%s%d", g_SrvName, 0);

	//GetPrivateProfileString("Option", "PldFileName", "ambpcx_v10_adm1624x192.mcs", g_pldFileName, sizeof(g_pldFileName), iniFilePath);
	GetInifileString(iniFilePath, "Option", "PldFileName", "ambpcx_v10_adm1624x192.mcs", g_pldFileName, sizeof(g_pldFileName));

	GetPrivateProfileString("Option", "isPldLoadAlways", "1", Buffer, sizeof(Buffer), iniFilePath);
	g_isPldLoadAlways = atoi(Buffer);
	GetPrivateProfileString("Option", "BusMasterEnable", "1", Buffer, sizeof(Buffer), iniFilePath);
	g_DmaOn = atoi(Buffer);
	if(g_DmaOn != 0 && g_info.busType == BRDbus_ETHERNET)
	{
		printf("Output on Ethernet: BusMasterEnable=0 ONLY !!!\n");		
		g_DmaOn = 0;
	}
	GetPrivateProfileString("Option", "Cycle", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_Cycle = atoi(Buffer);
	GetPrivateProfileString("Option", "IsReadFile", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_IsReadFile = atoi(Buffer);
	GetPrivateProfileString("Option", "SamplesPerChannel", "10240", Buffer, sizeof(Buffer), iniFilePath);
	g_samplesOfChannel = atoi(Buffer);
	GetPrivateProfileString("Option", "IsSystemMemory", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_IsSysMem = atoi(Buffer);
	if(g_IsSysMem == 1 && g_info.busType == BRDbus_ETHERNET)
	{
		printf("Ethernet: IsSystemMemory=0 or IsSystemMemory=2 ONLY (NOT EQUAL 1)!!!\n");		
		g_IsSysMem = 0;
	}
	GetPrivateProfileString("Option", "SignalFreqHz", "100.0", Buffer, sizeof(Buffer), iniFilePath);
	g_SignalFreq = atof(Buffer);
	GetPrivateProfileString("Option", "NumberOfPeriod", "1", Buffer, sizeof(Buffer), iniFilePath);
	g_NumberOfPeriod = atoi(Buffer);

	for(int i = 0; i < 16; i++)
	{
		sprintf_s(ParamName, "AmplitudemV%d", i);
		GetPrivateProfileString("Option", ParamName, "2000.0", Buffer, sizeof(Buffer), iniFilePath);
		g_Amplitude[i] = atof(Buffer);

		sprintf_s(ParamName, "FreqDivider%d", i);
		GetPrivateProfileString("Option", ParamName, "1", Buffer, sizeof(Buffer), iniFilePath);
		g_FreqDivider[i] = atoi(Buffer);
	}
	GetPrivateProfileString("Option", "WriteFile", "0", Buffer, sizeof(Buffer), iniFilePath);
	g_WriteFile = atoi(Buffer);
}

#include	<math.h>
#define TWO_PI (8.0*atan(1.0))
#define ROUND(x) ((int)floor((x) + 0.5))

template <class T1> void SignalBuf(T1* pSig, ULONG BufSize, ULONG idx, double Ampl, double DiscretePerPeriod)
{
	ULONG i, j;
	for(i = 0, j = 0; j < BufSize; i += idx, j++)
	  pSig[i] = (T1)ROUND(Ampl * sin(TWO_PI * j / DiscretePerPeriod));
}

S32 PutDataToSrv(BRD_Handle handle, BRD_ServList* srv, int idx)
{
	S32		status;
	U32 mode = BRDcapt_EXCLUSIVE;
	BRD_Handle hDAC = BRD_capture(handle, 0, &mode, srv->name, 10000);
	if(mode == BRDcapt_EXCLUSIVE) printf("DAC Capture mode: EXCLUSIVE\n");
	if(mode == BRDcapt_SPY)	printf("DAC Capture mode: SPY\n");
	if(hDAC > 0)
	{
		int numChan = DacSettings(hDAC, 0, g_SrvName, iniFileName); //   

		//ULONG cycling = 0; //   ( FIFO)
		//status = BRD_ctrl(hDAC, 0, BRDctrl_DAC_SETCYCLMODE, &cycling);
		//if(!BRD_errcmp(status, BRDerr_OK))
		//	DisplayError(status, "BRDctrl_DAC_SETCYCLMODE");

		//   
		ULONG format = 0;
		status = BRD_ctrl(hDAC, 0, BRDctrl_DAC_GETFORMAT, &format);
		ULONG sample_size = format ? format : sizeof(short); //    

		BRD_DacCfg dac_cfg;
		status = BRD_ctrl(hDAC, 0, BRDctrl_DAC_GETCFG, &dac_cfg);
		ULONG bits_sample = sample_size << 3; // * 8
		//ULONG bits_sample = (format == 1) ? 8 : dac_cfg.Bits; //    
		//if(format == 0 || format == 2)
			//bits_sample = 16;
		double rate;
		status = BRD_ctrl(hDAC, 0, BRDctrl_DAC_GETRATE, &rate);
		ULONG nBufSize = (UINT)ROUND(rate / g_SignalFreq * g_NumberOfPeriod);
		double DiscretePerPeriod = (double)nBufSize / g_NumberOfPeriod;
		ULONG bFifoBufSize = (nBufSize * numChan) * sample_size; //     FIFO   

		//if(g_DmaOn = 2)
		//{
		//	dac_cfg.FifoSize
		//}


		if(!g_DmaOn)
		{ //        FIFO
			ULONG bFifoWidth = 8;
			int fl_int = 1;
			int fl_dir = 0;
			for(int i = 0; i < numChan; i++)
				if(g_NumberOfPeriod % g_FreqDivider[i])
					fl_int = 0;
			while((bFifoBufSize > dac_cfg.FifoSize - bFifoWidth) || (bFifoBufSize % bFifoWidth) || !fl_int)
			{
				if(fl_dir)
				{
					g_NumberOfPeriod++;
					if(bFifoBufSize > dac_cfg.FifoSize - bFifoWidth)
					{
						printf("ERORRR:: Algoritm decrease / increase number of period NOT WORK.\n");
						status = BRD_release(hDAC, 0);
						return status;
					} 
				}
				else
				{
					g_NumberOfPeriod--;
					if(!g_NumberOfPeriod)
					{
						fl_dir = 1;
						g_NumberOfPeriod++;
					}
				}
				//{
					//printf("ERORRR:: FIFO size not enough for 1 period of signal\n");
					//status = BRD_release(hDAC, 0);
					//return status;
				//} 
				nBufSize = (UINT)ROUND(rate / g_SignalFreq * g_NumberOfPeriod);
				DiscretePerPeriod = (double)nBufSize / g_NumberOfPeriod;
				bFifoBufSize = (nBufSize * numChan) * sample_size; //     FIFO   
				fl_int = 1;
				for(int i = 0; i < numChan; i++)
					if(g_NumberOfPeriod % g_FreqDivider[i])
						fl_int = 0;
			}
			if(bFifoBufSize % bFifoWidth)
				printf("ERORRR:: Buffer size (%d) NOT multiple of FIFO Width (%d)\n", bFifoBufSize, bFifoWidth);
			for(int i = 0; i < numChan; i++)
				if(g_NumberOfPeriod % g_FreqDivider[i])
					printf("ERORRR:: Channel %d is NOT integer number of periods = %.2f\n", i, (double)g_NumberOfPeriod / g_FreqDivider[i]);
		}
		g_SignalFreq = rate / DiscretePerPeriod;
		printf("Signal Frequency = %.2f Hz\n", g_SignalFreq);
		printf("Number Of Periods = %d, Samples Of Channel = %d\n", g_NumberOfPeriod, nBufSize);
		
		double Ampl[16];
	//	double Freq[16];
		int i = 0;
		for(i = 0; i < numChan; i++)
		{
			Ampl[i] = g_Amplitude[i] * (double)((1 << (bits_sample - 1)) - 1) / dac_cfg.OutRange;
			//Freq[i] = g_SignalFreq / g_FreqDivider[i];
		}
		//Ampl[0] = g_Amplitude[0] * (double)((1 << (bits_sample - 1)) - 1) / dac_cfg.OutRange;
		//Ampl[2] = g_Amplitude[1] * (double)((1 << (bits_sample - 1)) - 1) / dac_cfg.OutRange;
		//Ampl[1] = g_Amplitude[2] * (double)((1 << (bits_sample - 1)) - 1) / dac_cfg.OutRange;
		//Ampl[3] = g_Amplitude[3] * (double)((1 << (bits_sample - 1)) - 1) / dac_cfg.OutRange;

		PVOID pSig = NULL;
		ULONG bBufSize = 0;
		if(g_DmaOn)
		{ //        
			bBufSize = (nBufSize * numChan) * sample_size; //      
			printf("Buffer size = %d bytes\n", bBufSize);
			status = AllocBuf(hDAC, &pSig, bBufSize, g_IsSysMem);
			if(!BRD_errcmp(status, BRDerr_OK))
				return status;
			//__int64* int64Sig = (__int64*)pSig;
			int* intSig = (int*)pSig;
			short* shortSig = (short*)pSig;
			char* charSig = (char*)pSig;
			switch(sample_size)
			{
			case 1:
				for(i = 0; i < numChan; i++)
					SignalBuf(charSig+i, nBufSize, numChan, Ampl[i], DiscretePerPeriod * g_FreqDivider[i]);
				break;
			case 2:
				for(i = 0; i < numChan; i++)
					SignalBuf(shortSig+i, nBufSize, numChan, Ampl[i], DiscretePerPeriod * g_FreqDivider[i]);
				break;
			case 4:
				for(i = 0; i < numChan; i++)
					SignalBuf(intSig+i, nBufSize, numChan, Ampl[i], DiscretePerPeriod * g_FreqDivider[i]);
				break;
			}
			status = OutputUseDMA(hDAC, idx, bBufSize, g_Cycle); //   
			if(g_WriteFile)
				WriteDataFile(g_WriteFile, pSig, bBufSize);
			status = FreeBuf(hDAC);
		}
		else
		{ //      FIFO
			//bFifoBufSize = 8192;
			//nBufSize = bFifoBufSize / 2;
			bBufSize = bFifoBufSize;
			pSig = new char[bBufSize];
			printf("Buffer size = %d bytes\n", bBufSize);
			//__int64* int64Sig = (__int64*)pSig;
			int* intSig = (int*)pSig;
			short* shortSig = (short*)pSig;
			char* charSig = (char*)pSig;
			switch(sample_size)
			{
			case 1:
				for(i = 0; i < numChan; i++)
					SignalBuf(charSig+i, nBufSize, numChan, Ampl[i], DiscretePerPeriod * g_FreqDivider[i]);
				break;
			case 2:
				for(i = 0; i < numChan; i++)
					//for(int j = 0; j < nBufSize/32; j++)
					//{
					//	for(i = 0; i < 16; i++)
					//		*(shortSig++) = (16 - i) * (-1024);
					//	for(i = 0; i < 16; i++)
					//		*(shortSig++) = i * 1024;
					//}
					
				//for(int j = 0; j < nBufSize; j++)
				//	*(shortSig++) = (-16000) + j * 32;
					SignalBuf(shortSig+i, nBufSize, numChan, Ampl[i], DiscretePerPeriod * g_FreqDivider[i]);
				break;
			case 4:
				for(i = 0; i < numChan; i++)
					SignalBuf(intSig+i, nBufSize, numChan, Ampl[i], DiscretePerPeriod * g_FreqDivider[i]);
				break;
			}
			status = OutputFifo(hDAC, pSig, bFifoBufSize, g_Cycle); //   

			if(g_WriteFile)
				WriteDataFile(g_WriteFile, pSig, bBufSize);
			delete pSig;
		}

		status = BRD_release(hDAC, 0);
	}
	return status;
}

void WriteDataFile(int idx, PVOID pBuf, ULONG nNumberOfBytes)
{
	TCHAR fileName[64];
//	sprintf_s(fileName, "data_%d.bin", idx);
	sprintf_s(fileName, "dac_data.bin", idx);
	HANDLE hfile = CreateFile(	fileName,
								GENERIC_WRITE,
								FILE_SHARE_WRITE,
								NULL,
								CREATE_ALWAYS,
								FILE_ATTRIBUTE_NORMAL,
								NULL);
	if(hfile == INVALID_HANDLE_VALUE)
	{
		printf("Create file error\n");
		return;
	}
	ULONG nNumberOfWriteBytes;

	BOOL bResult = 0;
	for(int i = 0; i < idx; i++)
		bResult = WriteFile(hfile, pBuf, nNumberOfBytes, &nNumberOfWriteBytes, NULL);
	CloseHandle(hfile);
	if(bResult != TRUE)
		printf("Write file error\n");
}

//
// End of file
//
